/*
 * Copyright (C) 2010 Ken Ellinwood.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package kellinwood.security.zipsigner;

public interface ProgressListener {

    /** Called to notify the listener that progress has been made during
        the zip signing operation.
        @param currentItem the name of the item being processed.
        @param percentDone a value between 0 and 100 indicating 
               percent complete.
    */
    public void onProgress( String currentItem, int percentDone);
}